<?php

namespace Drupal\monarch_entity_autocomplete_hooks\Controller;

use Symfony\Component\HttpFoundation\Request;
use Drupal\system\Controller\EntityAutocompleteController as EntityAutocompleteControllerOriginal;

/**
 * Defines a route controller for entity autocomplete form elements.
 */
class EntityAutocompleteController extends EntityAutocompleteControllerOriginal {

  /**
   * {@inheritdoc}
   */
  public function handleAutocomplete(Request $request, $target_type, $selection_handler, $selection_settings_key) {
    $response = parent::handleAutocomplete($request, $target_type, $selection_handler, $selection_settings_key);

    $json = json_decode($response->getContent());
    $params = [
      'request' => $request,
      'target_type' => $target_type,
      'selection_handler' => $selection_handler,
      'selection_settings_key' => $selection_settings_key,
    ];

    $this->moduleHandler()->alter([
      'entity_autocomplete_matches',
      $target_type . '_autocomplete_matches',
    ], $json, $params);

    $response->setContent(json_encode($json));

    return $response;
  }

}
