<?php

namespace Drupal\monarch_entity_autocomplete_hooks\EventSubscriber;

use Drupal\Core\Routing\RouteSubscriberBase;
use Drupal\Core\Routing\RoutingEvents;
use Symfony\Component\Routing\RouteCollection;
use Drupal\system\Controller\EntityAutocompleteController as EntityAutocompleteControllerOriginal;
use Drupal\monarch_entity_autocomplete_hooks\Controller\EntityAutocompleteController;

/**
 * The route subscriber to hijack the entity autocomplete class.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if ($route = $collection->get('system.entity_autocomplete')) {
      $original_class_name = EntityAutocompleteControllerOriginal::class;

      if ($route->getDefault('_controller') === "\\$original_class_name::handleAutocomplete") {
        $class_name = EntityAutocompleteController::class;
        $route->setDefault('_controller', "\\$class_name::handleAutocomplete");
      }
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    $events = parent::getSubscribedEvents();

    // Use a lower priority than \Drupal\views\EventSubscriber\RouteSubscriber
    // to ensure the requirement will be added to its routes.
    $events[RoutingEvents::ALTER] = ['onAlterRoutes', -300];

    return $events;
  }

}
